<?php
/*
Plugin Name: Book Reading
Plugin URI: http://www.viewfinderdesign.co.uk/
Description: Allows you to easily manage and maintain book lists and reviews
Version: 0.9
Author: Lee Penney
Author URI: http://www.thedigeratipeninsula.org.uk/

copyright (c) 2005 Lee Penney
Released under the terms of the GNU GPL
*/


function add_book_pages() {
  add_submenu_page('post.php', 'Write Book Entry', 'Write Book Entry', 1, 'book-new.php', '');
	add_submenu_page('edit.php', 'Edit Book Entry', 'Books', 1, 'book-edit.php', '');
}

add_action('admin_menu', 'add_book_pages');

function add_book_styles() {
  $url = get_settings('siteurl');
  $url = $url . '/wp-content/plugins/book_reading/book_reading.css';
  echo '<link rel="stylesheet" type="text/css" href="' . $url . '" />';
}

add_action('admin_head', 'add_book_styles');

function get_book_image($post_ID) {
  global $wpdb;
  $image_url = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='book_image' AND post_id='$post_ID'");
	return $image_url[0];
}

function get_book_author($post_ID) {
  global $wpdb;
  $author = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='author' AND post_id='$post_ID'");
	return $author[0];
}

function get_book_link($post_ID) {
  global $wpdb;
  $book_link = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='book_link' AND post_id='$post_ID'");
	return $book_link[0];
}

function get_book_recommendation($post_ID) {
  global $wpdb;
  $recommendation = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='recommend' AND post_id='$post_ID'");
	return $recommendation[0];
}

function get_books($cat_ID) {
  global $wpdb;
	
	$sql = "SELECT post_id FROM $wpdb->post2cat WHERE category_id='$cat_ID' ORDER BY rel_id DESC";
	$query = mysql_query($sql);
		
	$c = 0;
	
	while ($book = mysql_fetch_array($query)) {
		$book_img = get_book_image($book['post_id']);
		$book_link = get_book_link($book['post_id']);
		$author = get_book_author($book['post_id']);
		$recommend = get_book_recommendation($book['post_id']);
		$titletemp = $wpdb->get_row("SELECT post_title,post_content FROM $wpdb->posts WHERE ID='$book[post_id]'",'ARRAY_N');
		$title = $titletemp[0];
		$content = $titletemp[1];
		$booklist[$c] = $title."|".$author."|".$recommend."|".$book_img."|".$book_link."|".$content."|".$book['post_id']; 
		$c++;
	}
	
	return $booklist;
}

function display_books($cat_ID) {
  $books = get_books($cat_ID);
	$c = 0;
  foreach ($books as $book) {
	  $details = explode("|",$book);
		$title = $details[0];
		$author = $details[1];
		$recommend = ucwords($details[2]);
		$image = $details[3];
		$link = $details[4];
		$content = $details[5];
		$id = $details[6];

		// This is where the output starts, edit this bit to fit your site or how you want them displayed
		echo "<div class=\"book\">";
		if ($image != '' && $link != '') {
		  echo "<a href=\"$link\" title=\"$title\"><img src=\"$image\" alt=\"$title book cover\" class=\"bookimg\" /></a>";
		}	elseif ($image != '') {
		  echo "<img src=\"$image\" alt=\"$title book cover\" class=\"bookimg\" />";
		}
	  echo "<h3>$title</h3>";
		echo "<p class=\"author\">by $author</p>";
		echo "<p>Recommend: $recommend</p>";
		$content = apply_filters('the_content', $content);
    $content = str_replace(']]>', ']]&gt;', $content);
    echo $content;
		echo "<p><a href=\"$link\" title=\"Buy $title from Amazon\">Buy from Amazon.co.uk</a></p>";
		echo "</div>";
		//End of display layout
	}
}

function get_books_by_author() {
global $wpdb;

$authors = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='author' GROUP BY meta_value");

foreach ($authors as $author) {
  echo "<h3>$author</h3>\n";
	$books = $wpdb->get_results("SELECT * FROM $wpdb->postmeta INNER JOIN $wpdb->posts ON $wpdb->postmeta.post_id=$wpdb->posts.ID WHERE meta_value='$author' AND ($wpdb->posts.post_status='publish' OR $wpdb->posts.post_status='static')", ARRAY_A);
  echo "<ul class=\"books\">\n";
	$c = 0;
	foreach ($books as $book) {
	  $link = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='link' AND $wpdb->postmeta.post_id='$book[post_id]'");
    $mylink = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='mylink' AND $wpdb->postmeta.post_id='$book[post_id]'");
    $recommended = $wpdb->get_col("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key='recommend' AND $wpdb->postmeta.post_id='$book[post_id]'");
    if ( $c % 2 ) {
      echo "<li class=\"alt\"><span class=\"btitle\">$book[post_title]</span>";
		} else {
		  echo "<li><span class=\"btitle\">$book[post_title]</span>";
		}
		if ($recommended[0] != '') { ?>
		<span class="rec"><img src="<?php bloginfo('template_url') ?>/images/rec_<?php echo $recommended[0]; ?>.gif" alt="<?php echo $recommended[0]; ?> recommended image" width="15px" height="15px" style="width:15px;height:15px"></span>
    <?php } else {
		  echo "<span class=\"rec\">&nbsp;</span>";
		}
		if ($book['post_content'] != '') {
		printf("<span><a href=\"%s\" title=\"Read Review of %s\">Read Review</a></span>",$book['guid'],$book['post_title']);
		} else {
		  echo "<span>&nbsp;</span>";
		}
	  if ($link != '') { 
	  printf(" <span><a href=\"%s\" title=\"Buy %s New\">Buy New</a></span>",$link[0],$book['post_title']);
		} else {
		  echo "<span>&nbsp;</span>";
		}
		if ($mylink != '') { 
	  printf(" <span><a href=\"%s\" title=\"Buy %s Second Hand\">Buy My Copy</a></span>",$mylink[0],$book['post_title']);
		} else {
		  echo "<span>&nbsp;</span>";
		}
	  echo "<div class=\"clear\"></div></li>\n";
		$c++;
	}
	echo "</ul>\n";
}

}

?>